<template>
  <div class="q-pa-md">
    <q-table
      title="Groups"
      :rows="groups"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"
    >
      <template v-slot:body-cell-action="groups">
        <q-td :groups="groups" align="left" width="20px">
          <q-btn color="primary" icon="more_vert" size="sm">
            <q-menu
            transition-show="rotate"
          transition-hide="rotate"
          anchor="top left"
          self="top right"
            >
              <q-list style="min-width: 100px">
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <router-link to="student" class="group_tugma"> O'quvchilar </router-link>
                  </q-item-section>
                </q-item>
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <router-link to="student"  class="group_tugma"> Vazifalar </router-link>
                  </q-item-section>
                </q-item>
                <q-item clickable v-close-popup>
                  <q-item-section> 
                    <router-link to="student"  class="group_tugma"> Reyting </router-link>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-btn>
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(groups.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(groups.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add group"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          :disable="loading"
          label="Delete group"
          @click="ShowMoreDeleteModal()"
        />
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="search_text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Modallar Dialog -->
    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="AddModal = false"
      >
        <q-card-section>
          <div class="text-h6">New group</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="AddData.name" autofocus />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData" />
          <q-btn flat label="Cancel" @click="CloseAddModle" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Add Dialog -->

    <!-- Edit Dialog -->
    <q-dialog v-model="EditModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendEditModal"
        @keyup.esc="EditModal = false"
      >
        <q-card-section>
          <div class="text-h6">Edit group</div>
        </q-card-section>
        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input
            dense
            v-model="EditData.name"
            autofocus
            @keyup.enter="SendEditData"
            @keyup.esc="EditModal = false"
          />
        </q-card-section>
       
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Update" @click="SendEditData" />
          <q-btn flat label="Cancel" @click="EditModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Edit Dialog -->

    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete groups</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">Name:{{ DeleteData.name }}</div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this Categories ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="red" label="Delete" @click="sendmultiDelete" />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
  </div>
</template>

<script>
import { defineComponent } from 'vue'
import axios from 'axios'
import { ref } from 'vue'

export default defineComponent({
  name: 'PageIndex',
  data() {
    return {
      password_error: false,
      search_text: '',
      roles: [],
      allgroups:[],
      groups: [],
      selected: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: 'left',
          style: 'width: 10px',
          sortable: true,
        },
        {
          name: 'name',
          field: 'name',
          label: 'Group Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
      AddModal: false,
      AddData: {
        id: '',
        name: '',
      },
      EditModal: false,
      EditData: null,
      DeleteModal: false,
      multiDeleteModal: false,
      DeleteData: null,
    }
  },
  async mounted() {
    this.$q.loading.show()
    this.group()
    this.$q.loading.hide()
  
  },

  methods: {
    async group() {
      await axios
        .get(this.$domen()+'group/')
        .then((response) => {
          var data = response.data
          var a=[]

          for (var i = 0; i < data.length; i++) {
            var json = {
              index: i+1,
              id: data[i].id,
              name: data[i].name,
            }
            a.push(json)
          }
          this.groups=a
          console.log(this.groups);
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else {
            this.$e('Something Errors')
          }
        })
    },
    ShowAddModal() {
      this.AddModal = true
    },
    async SendAddData() {
      console.log(this.AddData)
      this.$q.loading.show()
      await axios
        .post(
          this.$domen()+'group/create_group',
          this.AddData
        )
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 201) {
            this.$s('Succesfully Create group Data')
          this.AddData = {
              id: '',
              name: '',
          }
            this.AddModal = false
            
            this.group()
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
            if (res.data.errors.email) {
              this.$e(res.data.errors.email[0])
            }
            if (res.data.errors.password) {
              this.$e(res.data.errors.password[0])
            }
            if (res.data.errors.role_id) {
              this.$e(res.data.errors.role_id[0])
            }
          } else {
            this.$e('Something Error')
          }
        })
      
      this.$q.loading.hide()
    },
   
    ShowEditModal(data) {
      console.log(data)
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name,
      }
    },
    async SendEditData() {
      if (this.EditData.name.length < 3) {
        this.$e('The name must be at least 3 characters.')
        return 0
      }
      this.$q.loading.show()
      await axios
        .post(
          this.$domen()+'group/update_group',
          this.EditData,
        )
        .then((res) => {
          
          if (res.status == 200) {
            this.$s('Succesfully Update group Data')
            this.EditModal = false
            this.$q.loading.hide()
            this.group()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
          } else {
            this.$e('Something Error')
          }
        })

      this.$q.loading.hide()
    },
    ShowDeleteModal(group) {
      this.DeleteData = {
        id: group.id,
        name: group.name,
      }
      this.DeleteModal = true
    },
    async SendDeleteData() {
      this.$q.loading.show()
      await axios
        .post(
          this.$domen()+'group/delete_group',
          this.DeleteData,
        )
        .then((res) => {
          //console.log(res.msg)

          if (res.status == 200) {
            this.$s('Succesfully Delete group')
            this.DeleteModal = false
            this.group()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (res.status == 401) {
            this.$e('You are not authorized')
            this.$q.loading.hide()
            this.$router
              .push('/login')
              .then((s) => {})
              .catch((e) => {})
          } else if (res.status == 422) {
            if (res.data.errors.name) {
              this.$e(res.data.errors.name[0])
            }
          } else {
            this.$e('Something Error')
          }
        })

      this.$q.loading.hide()
    },
    CloseAddModle() {
      this.AddModal = false
      this.AddData = {
        id: '',
        name: '',
      }
    },
    ShowMoreDeleteModal () {
      this.multiDeleteModal = true
    },
    async sendmultiDelete () {
      this.$q.loading.show()
      let sender = JSON.stringify(this.selected)
      await axios
        .post(this.$domen()+'group/multidelete', {
          data: sender
        })
        .then((res) => {
          if (res.status === 200) {
             this.$s('Succesfully Delete groups')
            this.multiDeleteModal = false
          }
        })
        .catch((e) => {
          
            this.$e('Something Error')
         
        })
      this.group()
      this.selected = []
      this.$q.loading.hide()
    },
  },
})
</script>
<style scoped>
.group_tugma{
  color: initial;
  text-decoration: none;
}
</style>